/** This is the general header for program METACUBE **/

#ifndef METACUBE_H_INCLUDED
#define METACUBE_H_INCLUDED


/** CUSTOMIZABLE PARAMETERS **/

#define VERSION "1.0" // Version number of the program


/** REQUIRED HEADERS **/

#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <string.h>


/** STRUCTURES **/

/* "int3" is a struct type combining three int variables "x", "y", "z" */

struct int3
{
  int x;
  int y;
  int z;
};

/* "double3" is a struct type combining three double variables "x", "y", "z" */

struct double3
{
  double x;
  double y;
  double z;
};

/* "double33" is a struct type combining three (struct double3) variables "x", "y", "z" */

struct double33
{
  struct double3 x;
  struct double3 y;
  struct double3 z;
};


/** CORE FUNCTION PROTOTYPES **/

/* Main function has the following syntax: ./metacube input.cube [-p|-v] [-k=blocksize] [-o=output.cube|-w] */

int main (int argc, char *argv[]);

/* Function "recube" changes punctual density data into volumic data. "*p_density" is the place data are stocked at and "nnn" is the size of the data grid */

void recube (double ****p_density, struct int3 nnn);


/** AUXILIARY FUNCTION PROTOTYPES **/

#include "auxfunctions.h"

#endif // METACUBE_H_INCLUDED
